function OperatingSystemController(){
    if(arguments.callee._singletonInstance){
	    return arguments.callee._singletonInstance;
	}
	arguments.callee._singletonInstance = this;
    
	var self = this; self.name = "OperatingSystemController"; // MANDATORY
    this.rootDir = "";
    
    this.uses_texture_graphics = false;
    
    this.storage = false;
    this.ready_callback = false;
    
    this.internet_connection = true;
    
    try{
      this.storage = window.localStorage;
    }catch(e){
      console.log("No localStorage available");
    }
    // TEMP
    /*
    if(this.storage){
      this.storage.clear();
    }
    */
    this.init = function(callback){
        // OVERRIDE
        callback();
    };
    
    this.writeFile = function(filename,value,callback,params){
        var clean_index = filename.indexOf("?");
        if(clean_index >= 0){
          filename = filename.subtring(0,clean_index+1);
        }
        // OVERRIDE
        self.log("Writting '"+filename+"' value: ");
        self.log(value);
        
        if(self.storage){
          self.storage.setItem(filename,value);
          if(typeof(callback) !== "undefined"){
              callback(true,filename,params);
          }        
        }else{
          if(typeof(callback) !== "undefined"){
              callback(false,filename,params);
          }        
        }        
    };
    
    this.appendFile = function(filename,value,callback,params){
        var clean_index = filename.indexOf("?");
        if(clean_index >= 0){
          filename = filename.subtring(0,clean_index+1);
        }
        // OVERRIDE
        self.log("Appending '"+filename+"' value: ");
        self.log(value);
        
        self.readFile(filename,function(data){
            if(data != ""){
              self.writeFile(filename,data+value,function(ok){
                if(typeof(callback) !== "undefined"){
                    callback(ok,filename,params);
                }
              });
            }else{
              if(typeof(callback) !== "undefined"){
                  callback(false,filename,params);
              }
            }
        });       
    };
    
    this.readFile = function(filename,callback,params){
        var value = "";
        var clean_index = filename.indexOf("?");
        if(clean_index >= 0){
          filename = filename.subtring(0,clean_index+1);
        }
        if(self.storage){
          value = self.storage.getItem(filename);
          if(value === null){
            value = "";
          }
          if(typeof(callback) !== "undefined"){
              callback(value,filename,params);
          }        
        }else{
          if(typeof(callback) !== "undefined"){
              callback(value,filename,params);
          }        
        } 
        
        if(typeof(callback) !== "undefined"){
            callback(value,filename,params);
        }
        return value;
    };
    
    this.fileExists = function(filename,callback,params){
        var clean_index = filename.indexOf("?");
        if(clean_index >= 0){
          filename = filename.subtring(0,clean_index+1);
        }
        if(self.storage){
          var value = self.storage.getItem(filename);
          if(value === null){
            value = false;
          }else{
            value = true;
          }
          if(typeof(callback) !== "undefined"){
              callback(value,filename,params);
          }        
        }else{
          if(typeof(callback) !== "undefined"){
              callback(false,filename,params);
          }        
        } 
    };
    
    this.makeDir = function(path,callback,params){
        // OVERRIDE
        if(typeof(callback) !== "undefined"){
            callback(true,path,params);
        }
    };

    this.modificationDate = function(filename,callback,params){
        // OVERRIDE
        //var date = new Date(0).getTime();
        var date = filename.replace("datos.xml?","");
        if(date == ""){
          date = ""+new Date(0).getTime();
        }
        if(typeof(callback) !== "undefined"){
            callback(date,filename,params);
        }
    };
    
    this.getNetworkInfo = function(callback,params){
        var network_info = {
            ip: "0.0.0.0",
            netmask : "0.0.0.0",
            gateway : "0.0.0.0"
        };
        if(typeof(callback) !== "undefined"){
            callback(network_info,params);
        }
        return network_info;
    };
    
    this.getInfoSystem = function(){

    };
    
    this.downloadFile = function(url,destFolder,callback,params){
        // OVERRIDE
    };
    
    this.unzipFile = function(filename,destFolder,callback,params){
        // OVERRIDE
    };
    
    this.readDirectory = function(directory,callback,params){
        // OVERRIDE
        
        var values = [],
        keys = Object.keys(self.storage),
        i = keys.length;

        while ( i-- ) {
            if(keys[i].indexOf(directory) >= 0){
              values.push(keys[i].substring(directory.length,keys[i].length));
            }
        }

        if(typeof(callback) !== "undefined"){
          callback(values,directory,params);
        }

    };
    
    this.watchDirectory = function(directory,compare_files,callback,params){
      var compare_index = -1;
      var changed = [];
      self.readDirectory(directory,function(files){
        for(var j=0;j<compare_files.length;j++){
            compare_index = files.indexOf(compare_files[j].filename);
            if(compare_index >= 0){
                var value = self.readFile(directory+files[compare_index]); 
                if(compare_files[j].value != value){
                    compare_files[j].value = value;
                    compare_files[j].mdate = new Date().getTime();
                    changed.push(compare_files[j]);
                }
            }else{
              if(compare_files[j].mdate != 0){
                  compare_files[j].mdate = 0;
                  changed.push(compare_files[j]);
              }
            }
        }
        if(typeof(callback) !== "undefined"){
            callback(compare_files,changed,params);
        }
      });
    };
    
    this.deleteFile = function(filename,callback,params){
      var clean_index = filename.indexOf("?");
      if(clean_index >= 0){
        filename = filename.subtring(0,clean_index+1);
      }
      if(self.storage){
        var value = self.storage.removeItem(filename);
        if(value === null){
          value = false;
        }else{
          value = true;
        }
        if(typeof(callback) !== "undefined"){
            callback(value,filename,params);
        }        
      }else{
        if(typeof(callback) !== "undefined"){
            callback(false,filename,params);
        }        
      } 
    };
    
    this.moveFile = function(source,destination,callback,params){
        // OVERRIDE
    };
    
    this.takeScreenshot = function(callback,params){
        // OVERRIDE 
    };
    
    this.setSystemDateTime = function(timestamp,callback,params){
        // OVERRIDE
    };
    
    this.requestSystemTimestamp = function(){
        return parseInt(new Date().getTime()/1000);
    };
        
    this.rebootSystem = function(){
        // OVERRIDE   
    };
    
    this.getScreens = function(){
        // OVERRIDE 
        var screens = [];
        screens[0] = {id:0,bounds:{x:0,y:0,width:400,height:300,scaleFactor:1}};
        return screens;
    };

    this.setWindow = function(x,y,w,h){  
        // OVERRIDE  
    };
    
    this.setProxyConfig = function(config){
        // OVERRIDE  
    };
    
    this.getProxyForURL = function(url){
        // OVERRIDE 
        return "";
    };  
    
    this.getAddWhiteList = function(sourceOrigin, destinationProtocol, destinationHost, allowDestinationSubdomains){
        // OVERRIDE  
    };
    
    this.getRemoveWhiteList = function(sourceOrigin, destinationProtocol, destinationHost, allowDestinationSubdomains){
        // OVERRIDE  
    };
    
    this.getDataPath = function(){
         // OVERRIDE  
    };
    
    this.setCrashDumpPath = function(folderPath){
         // OVERRIDE  
    };

    this.quit = function(){
        // OVERRIDE  
    };
    
    this.internetConnected = function() {
       self.internet_connection = true;

      return true;
    };
    
    this.clearCache = function(){
        // OVERRIDE  
    };
    
    this.alwaysOnTop = function(value){
        // OVERRIDE  
        self.uses_texture_graphics = !value;
    };
    
    this.focusWindow = function(){
        // OVERRIDE  
    };
    
    this.activateControl = function(){
        // OVERRIDE  
    };
    this.deactivateControl = function(){
        // OVERRIDE  
    };
    this.sendControlLog = function(name, text){
        // OVERRIDE  
    };
    this.saveIdContent = function(idContent){
        self.id_content_now = idContent;
    };
    this.changeCore = function(id){
        // OVERRIDE
    };
    
    this.saveCoreFile = function(core_id,api_ver,api_url,callback){
        var core_xml = '<?xml version="1.0" encoding="utf-8" ?><core><config><id>'+core_id+'</id><api_ver>'+api_ver+'</api_ver><api_url>'+api_url+'</api_url></config><server url="'+self.api_url+'"/></core>';  
        self.log(core_xml);
        self.writeFile(self.ROUTES['CORE'].path,core_xml,function(ok){
          if(typeof(callback) !== "undefined"){
              callback(ok);
          } 
        });
    };
}	
OperatingSystemController.prototype = new SystemController();
