'use strict';


var player = false;

// FOR ARM ARCH
var transfer = false;
var manager = false;


var beat_timer = false;
var service_timer = false;

var last_mouse_pos_x = 0;
var last_mouse_pos_y = 0;
var lastUserActivity = 0;

var last_active_player_status = "";
var last_active_player_status_modification = "";



function adaptPlayerWindowSize(){
  if(player){
    if(player.config){
      var is_fixed_size = false;
      var screen = player.config.getScreenConfig();
      if(screen.w == "100%"){
        screen.w = window.innerWidth;
      }else{
        is_fixed_size = true;
      }
      if(screen.h == "100%"){
        screen.h = window.innerHeight;
      }else{
        is_fixed_size = true;
      }
      if(is_fixed_size){
        player.OS.setMaxWindowDesktop(screen);
        player.setPlayerWindow();
      }else{
        player.OS.setMaxWindowDesktop();
        player.setPlayerWindow();
      }
    }
  }
}


$(document).ready(function(){
  setTimeout(function(){
    // WAIT NODE  JS TO START
    try{
      $.get('http://127.0.0.1:9090/brightsign.html', function(data, status) {
        console.log("Checking external App ...");
      }).done(function() {
        console.log("System is updatable.");
        if(document.location != 'http://127.0.0.1:9090/brightsign.html'){
          document.location = 'http://127.0.0.1:9090/brightsign.html';
        }else{
          initApp()
        }
      }).fail(function(e) {
        initApp()
      });
    }catch(e){
      initApp()
    } 
  },12000);
});

function initApp(){
  if(!service_timer){
      service_timer = setInterval(service,20000);
  }

  try{
    if(!player){
        player = new PlayerController();
        //player.activateLogger(true);
        $(player).on("PlayerDataLoaded",onPlayerDataLoaded);
        player.init();
        adaptPlayerWindowSize();
    }
  }catch(e){
    console.log("Unable to start player");
    var archive = [];
    try{
      archive = player.dataManager.getArchiveFiles();
    }catch(e){
      console.log("No Archive !");
    }
    var schedule = undefined;
    try{
      schedule = player.config.getScheduleConfig();
    }catch(e){
      console.log("No Schedule !");
    }
    try{
      if(!transfer){
          transfer = new TransferService();
          transfer.init(player.version);
      }
      transfer.update(player.timestamp,archive);
      transfer.activateLogger(player.debug);
    }catch(e){
      console.log("Unable to start transfer");
    }
    
    try{
      if(!manager){
          manager = new ManagerService();
          manager.init();
          try{
            transfer.onUpdatedManagerInterval = function(interval){
              console.log("Checking ManagerService Interval");
              manager.checkInterval(interval);
            };
          }catch(e){
            console.log("Could not check interval for management");
          }
      }
      var schedule = undefined;
      try{
        schedule = player.config.getScheduleConfig();
      }catch(e){
        console.log("No Schedule !");
      }
      manager.update(schedule);
      manager.activateLogger(player.debug);
    
    }catch(e){
      console.log("Unable to start manager");
    }
  }

  $(window).keypress(function(event){
      //console.log("KeyPress Code = "+event.which+" Shifted = "+self.keyboardShifted);
      lastUserActivity = parseInt(player.getDate().getTime()/1000);
  });
  $(window).on("mousemove",function(event) {
      //console.log("Mouse MOVE !!");
      lastUserActivity = parseInt(player.getDate().getTime()/1000);
  });
}


function beat(){
  
}

function service(){
    if(player){
      player.service();
      adaptPlayerWindowSize();
    }
}


function onPlayerDataLoaded(){
    //player.OS.setMaxWindowDesktop();
    //player.setPlayerWindow();
    adaptPlayerWindowSize();
    
    if(!beat_timer){
        beat_timer = setInterval(beat,1000);
    }

    var archive = [];
    try{
      archive = player.dataManager.getArchiveFiles();
    }catch(e){
      console.log("No Archive !");
    }
    var schedule = undefined;
    try{
      schedule = player.config.getScheduleConfig();
    }catch(e){
      console.log("No Schedule !");
    }
    try{
      if(!transfer){
          transfer = new TransferService();
          transfer.init(player.version);
      }
      transfer.update(player.timestamp,archive);
      transfer.activateLogger(player.debug);
    }catch(e){
      console.log("Unable to start transfer");
    }
    
    try{
      if(!manager){
          manager = new ManagerService();
          manager.init();
          try{
            transfer.onUpdatedManagerInterval = function(interval){
              console.log("Checking ManagerService Interval");
              manager.checkInterval(interval);
            };
          }catch(e){
            console.log("Could not check interval for management");
          }
      }
      var schedule = undefined;
      try{
        schedule = player.config.getScheduleConfig();
      }catch(e){
        console.log("No Schedule !");
      }
      manager.update(schedule);
      manager.activateLogger(player.debug);
    }catch(e){
      console.log("Unable to start manager");
    }
}
